"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const t = require("babel-types");
function buildConstVariableDeclaration(variableName, expresion) {
    return t.variableDeclaration('const', [
        t.variableDeclarator(t.identifier(variableName), expresion)
    ]);
}
exports.buildConstVariableDeclaration = buildConstVariableDeclaration;
function buildComponentPathDataset(path) {
    const parentPath = path.parentPath;
    if (parentPath.isJSXOpeningElement()) {
        parentPath.node.attributes.push(t.jSXAttribute(t.jSXIdentifier('data-__component_path'), t.stringLiteral('{{$path}}')));
    }
}
exports.buildComponentPathDataset = buildComponentPathDataset;
function buildAssignState(pendingState, initState) {
    return t.expressionStatement(t.callExpression(t.memberExpression(t.identifier('Object'), t.identifier('assign')), [
        initState.size > 0
            ? t.memberExpression(t.thisExpression(), t.identifier('state'))
            : t.objectExpression([]),
        pendingState
    ]));
}
exports.buildAssignState = buildAssignState;
function copyStateToShalowData() {
    return t.expressionStatement(t.assignmentExpression('=', t.memberExpression(t.memberExpression(t.thisExpression(), t.identifier('state')), t.identifier('__data')), t.callExpression(t.memberExpression(t.identifier('Object'), t.identifier('assign')), [
        t.objectExpression([]),
        t.memberExpression(t.thisExpression(), t.identifier('state'))
    ])));
}
exports.copyStateToShalowData = copyStateToShalowData;
//# sourceMappingURL=helpers.js.map